Ruby - Bug #19544

Custom quotes inconsistency
03/24/2023 03:46 AM - hurricup (Alexandr Evstigneev)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:
UNKNOWN, 3.2: UNKNOWN

Description

According to parse_percent in parse.y:

For % we should be able use ascii non alphanumeric delimiters.

But, p % jim beam ; does not work. Presumably because of some look-ahead distincting % from percent-string starter. Seems it is
the same for any \s after %

For the explicit % construction, with type specifier %[QqWwlisrx] we should be able to use non-alphanumeric ascii characters, which
includes \s. But:

This works:

p %s
jim beam

And this does not:

P %w
jim\ beam

with unterminated list error.

First seems unavoidable, but second looks like obvious error of finding terminating \n

Related issues:
Related to Ruby - Bug #19563: Ripper.tokenize(code).join = code when heredoc... Closed

History

#1 - 03/24/2023 04:55 AM - mame (Yusuke Endoh)

Presumably because of some look-ahead distincting % from percent-string starter

It depends on the lex state, not look-ahead. If you place % in a context where the beginning of an expression is expected, you can write %-literal with
spaces as delimiters.

o°

p(% foo ) #=> "foo"
p(% jim\ beam ) #=> "jim beam"

%w cannot be used with a space delimiter because it interprets all whitespace characters as a word delimiter.

#2 - 03/24/2023 05:05 AM - hurricup (Alexandr Evstigneev)

mame (Yusuke Endoh) wrote in #note-1:

Presumably because of some look-ahead distincting % from percent-string starter

It depends on the lex state, not look-ahead. If you place % in a context where the beginning of an expression is expected, you can write %-literal
with spaces as delimiters.

o

foo ) #=> "foo"

jim\ beam ) #=> "jim beam"

=X
=X

o

07/22/2025 1/2




%w cannot be used with a space delimiter because it interprets all whitespace characters as a word delimiter.

Thank you! This sounds reasonable. Then feels that list-like quotations ops [Wwli] should error about \s term, not unterminated list, which may be
confusing.

#3 - 03/24/2023 05:14 AM - hurricup (Alexandr Evstigneev)

mame (Yusuke Endoh) wrote in #note-1:

%w cannot be used with a space delimiter because it interprets all whitespace characters as a word delimiter.

Also, it could be usable, because space may be used as delimiter and \n as word separator and vice versa.

#4 - 07/11/2023 01:30 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #19563: Ripper.tokenize(code).join != code when heredoc and multiline %w[] literal is on the same line added

#5 - 07/11/2023 01:30 PM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Fixed at ac8a16237c727ae2a1446ef6dc810d0e750971fb.

07/22/2025 22


https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/ac8a16237c727ae2a1446ef6dc810d0e750971fb
